
(function ($, Drupal) {
  Drupal.behaviors.custom_jsoneditor = {
    attach: function (context) {
      $('.jsoneditor--wrapper').each(function () {
        if(this.editor) {
          return;
        }

        var options = {
          mode: 'tree',
          modes: ['code', 'tree', 'view', 'form', 'text'],
          ace: ace,
          container: this,
          onChangeText: function (jsonString) {
            var input = getInputFromContainer(this.container);
            if (input) {
              input.val(jsonString);
            }
          }
        };

        this.editor = new JSONEditor(this, options);
        var input = getInputFromContainer(this);

        if (input) {
          var inputValue = input.val();

          if (inputValue) {
            var json = JSON.parse(inputValue);
            this.editor.set(json);
          }
        }
      });
    },
  };

  function getInputFromContainer(container) {
    var inputName = $(container).data('input');

    if (inputName) {
      var input = $('input[name="' + inputName + '"]');

      if (input.length > 0) {
        return input;
      }
    }

    return null;
  }

  $.fn.updateJsonResponse = function (inputName, json) {
    var editorDiv = $('div.jsoneditor--wrapper[data-input="' + inputName + '"]:first');

    if (editorDiv.length > 0) {
      editorDiv[0].editor.set(json);
    }
  }

})(jQuery, Drupal);
